--with profile
--trace(1)
without type_check
clear_screen()
--***************************************
--  File:               PI.EX
--  Date:               3/21/97
--  Author:             James Powell (minor modification by Rob Craig)
--  Language:   Euphoria!
--
--              Translated to Euphoria from
--
--  File:               PI.TRU
--  Date:               2/28/85
--  Author:             John Craig -- no relation! 
--  Language:   True BASIC
--****************************************

-- Speed improvement by Michael Bolin
-- Approximately 2.5 times as fast.
-- For 200 digits on a 486DX2-66, from 6.54 seconds to 2.57 seconds

--Uses
include get.e
include file.e
--Contants
constant KEYB = 0
constant SCREEN = 1
constant ERR = 2
constant TRUE = 1
constant FALSE = 0

--Global Variables
integer Digits

--Functions

function Divide(integer dividend, integer divisor)
    integer quotient, remain
	quotient = floor(dividend / divisor)
	remain = remainder(dividend, divisor)
	return {quotient,remain}
end function

function Seq_add(sequence add_a, sequence add_b)
    integer quotient,remain,dividend
	
	quotient=0
	remain=0
	for looper = Digits to 1 by -1 do
	    dividend=add_a[looper]+add_b[looper]+quotient
	    quotient=floor(dividend / 10)
	    remain=remainder(dividend , 10)
	    add_a[looper]=remain
	end for
	return add_a
end function

function Seq_div(sequence div_seq, integer div)
    integer quotient,remain,dividend
    
	quotient=0
	remain=0
	for looper = 1 to Digits do
	    dividend=remain*10+div_seq[looper]
	    quotient=floor(dividend / div)
	    remain=remainder(dividend, div)
	    div_seq[looper]=quotient
	end for
	return div_seq
end function

function Seq_mult(sequence mult_seq, integer mult)
    integer quotient,remain,dividend
    
	quotient=0
	remain=0
	for looper = Digits to 1 by -1 do
	    dividend=mult_seq[looper]*mult+quotient
	    quotient=floor(dividend / 10)
	    remain=remainder(dividend , 10)
	    mult_seq[looper] = remain
	end for
	return mult_seq
end function

function Seq_sub(sequence sub_a, sequence sub_b)
    integer quotient,remain,dividend

	quotient=0
	remain=0
	for looper = Digits to 1 by -1 do
	    dividend=sub_a[looper]-sub_b[looper]+10
	    quotient=floor(dividend / 10)
	    remain=remainder(dividend , 10)
	    sub_a[looper]=remain
	    if quotient=0 then
		sub_a[looper - 1] = sub_a[looper - 1] - 1
	    end if
	end for
	return sub_a
end function

function Seq_Zero(sequence zero_a)
	for looper = 1 to Digits do
	    if zero_a[looper] != 0 then
		return FALSE
		exit
	    end if
	end for
	return TRUE
end function

function Arc_tan(sequence arc_a, sequence arc_b, integer arc_s)
    sequence temp
    integer m, n, ZERO_FLAG
	arc_b[1] = 1
	m = arc_s
	arc_b = Seq_div(arc_b, m)
	arc_a = Seq_add(arc_a, arc_b)
	n = 1
	ZERO_FLAG = FALSE
	while not ZERO_FLAG do
	    arc_b = Seq_mult(arc_b, n)
	    m = arc_s * arc_s
	    arc_b = Seq_div(arc_b, m)
	    n = n + 2
	    m = n
	    arc_b = Seq_div(arc_b, m)
	    temp = Divide(floor((n - 1) / 2), 2)
	    if temp[2] = 1 then
		arc_a = Seq_sub(arc_a, arc_b)
	    else
		arc_a = Seq_add(arc_a, arc_b)
	    end if
	    ZERO_FLAG = Seq_Zero(arc_b)
	end while
	return {arc_a, arc_b}
end function


object inp
sequence main_seq,q
object inpi
integer s
integer t
atom start_time, end_time,i
procedure input()
    puts(SCREEN, "This program calculates Pi\n")
    puts(SCREEN, "\nHow many digits would you like to calculate Pi to?\n")
    inp = get(KEYB)
    if (inp[1] = GET_SUCCESS) and (integer(inp[2])) then
	Digits = inp[2] + 1 
    else
	puts(ERR, "\n\n\nYou must enter an integer value!\n\n")
    input()
    end if

    start_time = time()
    s = 2
    main_seq = {0, 0}
    main_seq[1] = repeat(0, Digits)
    main_seq[2] = repeat(0, Digits)
    main_seq = Arc_tan(main_seq[1], main_seq[2], s)
    s = 3
    main_seq = Arc_tan(main_seq[1], main_seq[2], s)
    main_seq[1] = Seq_mult(main_seq[1], 4)
    end_time = time()
    printf(SCREEN, "\nPi, to %d digits, is approximately:\n",Digits-1)
    inpi = dir("pi.txt")
    i = atom(inpi[1])
    if i = 1 then
    t = open("pi.txt","w")
    elsif inpi[1][3]-1 > inp[2] then
	t = open("pi.tmp","w")
    else      
	t = open("pi.txt","w")
    end if
    for looper = 1 to Digits - 1 do
	printf(SCREEN, "%d",main_seq[1][looper])
	printf(t, "%d",main_seq[1][looper])
	if looper = 1 then
	    puts(SCREEN, ".")
	    puts(t, ".")
	end if
    
    end for

    printf(SCREEN, "\n\nIt took %g seconds to calculate \n\n",
		    (end_time - start_time))
    if inpi[1][3] > inp[2] then
	q = "mp"
    else q = "xt"
    end if              
    printf(SCREEN, "See the results in Pi.t%s%s\n\n",{q[1],q[2]})
end procedure
input()
